/*********************************************************************
 *  PIC32MX g`
 *	DMAŃ璼I/O֓]D/ARo[^𐧌
 *	DMA]8MHz@@o͔g`ōg160kHz
 *********************************************************************/
#include <plib.h>       				 /* PIC32 peripheral library */

//  RtBM[Vݒ
//  CPU=80<Hz Peri=40MHz, HS+PLL, Divider=1/2,  PLL=20x,  WDT=Off
#pragma config FNOSC = PRIPLL, POSCMOD = HS, FPLLIDIV = DIV_2
#pragma config FPLLMUL = MUL_20, FPBDIV = DIV_1, FPLLODIV = DIV_1
#pragma config FWDTEN = OFF, OSCIOFNC = ON, ICESEL = ICS_PGx1
// 萔`
#define	SYS_FREQ			80000000		// Fcy
/***** LCD֘Aݒ ******/
#define	LCD_DATA		LATB				// Srbgf[^̏o̓|[g
#define	LCD_RS		LATBbits.LATB10	// RSM
#define	LCD_E		LATBbits.LATB11	// E(STB)M
void delay_us(int usec);
void delay_ms(int msec);
void lcd_out(char code, char flag);
void lcd_data(char asci);
void lcd_cmd(char cmd);
void lcd_clear(void);
void lcd_init(void);
void lcd_str(const char *str);
#include "LCD_Lib1.c"
// ֐vg^CsO
void itostring(char digit, unsigned int data, char *buffer);
void ftostring(int seisu, int shousu, float data, char *buffer);
// t\탁bZ[W萔
const char MsgStart[] = "Start!";
char MsgData1[] = "Width=xxxxxx.xus";		// position=6
char MsgData2[] = "Freq=xxxxxx.x Hz";		// position=5
char MsgRes[]   = "Resolution = xxx";		// position=13
// g`f[^iő256oCgȉ) 
static unsigned char Pattern[256];
// O[oϐ`
int i, dmaChn, Width, MaxRes, WaveKind, Flag;
float Pulse, Freq;

/**************** 荞ݏ *********************/
/******************************************
*  INT0荞ݏi[^XCb`j
******************************************/
void __ISR(3, ipl2) INT0_Handler(void)
{
	if(PORTFbits.RF5 == 1){				// E]`FbN
		if(Width > 5000)
			Width += 1000;
		if(Width > 500)					// ]g_E
			Width += 100;					// gł̓Xebv傫
		else
			Width++;
		if(Width > 32500)					// `FbN
			Width = 32500;
	}
	else{								// E]gAbv
		if(Width >= 5000)
			Width -= 1000;
		if(Width >= 500)
			Width -= 100;					// gł̓Xebv傫
		else
			Width--;
		if(Width < 4)						// `FbN
			Width = 4;
	}
	while(PORTFbits.RF6 == 0);				// SWI̊ԑ҂	
	Flag = 1;							// g`XVtOI
	mINT0ClearIntFlag();					// 荞݃tONA	
}

/******************************************
*  INT1荞ݏiSW1)
*  g`ʐؑ֐
******************************************/
void __ISR(7, ipl3) INT1Handler(void)
{
	WaveKind++;							// g`wXV
	if(WaveKind > 5)						// 5ނŏz
		WaveKind = 0;
	lcd_clear();							// LCD
	/**** t\ɔg`ʕ\ ******/
	switch(WaveKind){	
		case 0: lcd_str("Sine Wave");
				break;
		case 1: lcd_str("Rectangular Wave");
				break;
		case 2: lcd_str("Triangle Wave");
				break;
		case 3: lcd_str("Saw Wave");
				break;
		case 4: lcd_str("User Define1");
				break;
		case 5: lcd_str("User Define2");
				break;
		default:lcd_str("Wave = ?????");
	}
	delay_ms(800);						// 0.8b҂\mF
	while(PORTDbits.RD9 == 0);				// XCb`I̊ԑ҂
	Flag = 1;							// g`XVtOI
	mINT1ClearIntFlag();					// 荞݃tONA
}

/******************************************
*  INT2荞ݏiSW2)
*  D/A`lؑ֐
******************************************/
void __ISR(11, ipl3) INT2Handler(void)
{
	lcd_clear();							// LCD
	if(PORTGbits.RG6 == 0){				// `lؑ
		LATGbits.LATG6 = 1;
		lcd_str("Select Channel B");		// Bؑ֕\
	}
	else{
		LATGbits.LATG6 = 0;
		lcd_str("Select Channel A");		// Aؑ֕\
	}
	delay_ms(800);						// \mF҂
	while(PORTDbits.RD10 == 0);			// XCb`I̊ԑ҂
	Flag = 1;							// g`XVtOI
	mINT2ClearIntFlag();					// 荞݃tONA		
}
		
/******************************************
*  INT3荞ݏiSW3)
*  \̐ݒ萧@ō\255
******************************************/
void __ISR(15, ipl3) INT3Handler(void)
{
	lcd_clear();							// LCD
	if(MaxRes == 20)
		MaxRes += 30;						// \+50
	else
		MaxRes += 50;
	if(MaxRes > 250)						// 250\𒴂H
		MaxRes = 20;
	itostring(3, MaxRes, MsgRes+13);		// \𕶎ϊ
	lcd_str(MsgRes);						// LCDɕ\
	delay_ms(800);						// \mF҂
	while(PORTDbits.RD11 == 0);			// XCb`I̊ԑ҂
	Flag = 1;							// g`XVtOI
	mINT3ClearIntFlag();					// 荞݃tONA
}

/****************** C֐ ************************/
int main(void)
{
	/**** VXeݒ  ****/
	SYSTEMConfigPerformance(80000000);		// VXeő
	mJTAGPortEnable(DEBUG_JTAGPORT_OFF);	// JTAG𖳌
	/***** I/Oo̓[hݒ *******/
	mPORTBSetPinsDigitalOut(0xFFFF);		// LCD,LED
	mPORTCSetPinsDigitalIn(0xF000);			// NC
	mPORTDSetPinsDigitalOut(0x00FF);		// D/S CS
	mPORTDSetPinsDigitalIn(0xFF00);			// Sw1-3
	mPORTESetPinsDigitalOut(0xFFFF);		// D/A
	mPORTFSetPinsDigitalIn(0x0064);			// Rotally
	mPORTFSetPinsDigitalOut(0x0093);		// SW,D/A
	mPORTGSetPinsDigitalOut(0xFFFF);		// D/A
	/******* DMAݒ *******/
	/* AUTOŎJԂANgK^C}3荞 */	
	DmaChnOpen(dmaChn, 0, DMA_OPEN_AUTO);
	DmaChnSetEventControl(dmaChn, DMA_EV_START_IRQ(_TIMER_3_IRQ));
	/**** o̓RyAݒ@*****/
	OpenOC5(OC_ON | OC_TIMER_MODE16 | OC_TIMER3_SRC | OC_CONTINUE_PULSE | OC_LOW_HIGH, 0x2, 0x6);
	/**** D/A`lAI  ****/
	LATGbits.LATG6 = 0;	
	/**** VXeϐ  *****/
	dmaChn = 0;							// DMA`l0gp
	Width = 4;							// o̓pXōɏݒ
	MaxRes = 200;							// ő啪\ݒ
	Flag = 1;							// g`XVtOI
	WaveKind = 0;							// g`ʐgݒ
	/**** t\̏ƊJnbZ[W\@*****/
	lcd_init();
	lcd_str(MsgStart);
	/*** XCb`荞݋ *****/
	ConfigINT0(EXT_INT_ENABLE | FALLING_EDGE_INT | EXT_INT_PRI_2);
	ConfigINT1(EXT_INT_ENABLE | RISING_EDGE_INT | EXT_INT_PRI_3);
	ConfigINT2(EXT_INT_ENABLE | RISING_EDGE_INT | EXT_INT_PRI_4);
	ConfigINT3(EXT_INT_ENABLE | RISING_EDGE_INT | EXT_INT_PRI_5);
	mINT0ClearIntFlag();					// 荞݃tONA
	mINT1ClearIntFlag();					// 荞݃tONA
	mINT2ClearIntFlag();					// 荞݃tONA
	mINT3ClearIntFlag();					// 荞݃tONA	
	INTEnableSystemMultiVectoredInt();		// 荞݋

	/********************** C[v ***********************/
	while(1)
	{
		if(Flag == 1)								// g`XVtOIH
		{		
			/***** g`f[^ ****/
			switch(WaveKind)						// g`ʂŕ򂵔g`f[^
			{
				case 0:					// g
					for(i=0; i<MaxRes; i++)
						Pattern[i] = (char)(128 + 128 * sinf(i*6.28/MaxRes));	
					break;
				case 1:					// `g
					for(i=0; i<MaxRes/2; i++)
						Pattern[i] = 0;
					for(i=MaxRes/2; i<MaxRes; i++)
						Pattern[i] = 255;
					break;						
				case 2:					// Opg
					for(i=0; i<MaxRes/2; i++)
						Pattern[i] = (char)(255 * 2*i/MaxRes);
					for(i=MaxRes/2; i<MaxRes; i++)
						Pattern[i] = (char)(255 * 2*(MaxRes-i)/MaxRes);
					break;
				case 3:					// g
					for(i=0; i<MaxRes; i++)
						Pattern[i] = (char)(255 * i/MaxRes);
					break;
	
				case 4:					// g
					for(i=0; i<MaxRes; i++)
						Pattern[i] = (char)(128+64*sinf(i*6.28/MaxRes)+
										64*sinf(2*i*6.28/MaxRes));
					break;
				case 5:					// g
					for(i=0; i<MaxRes; i++)
						Pattern[i] = (char)(128+42*sinf(i*6.28/MaxRes)+
										42*sinf(2*i*6.28/MaxRes)
										+42*sinf(3*i*6.28/MaxRes));
					break;				
				default:					// g
					for(i=0; i<MaxRes+1; i++)
						Pattern[i] = (char)(128 + 128 * sinf(6.28*i/MaxRes));
					break;
			}
			/***** ^C}3ݒ ****/
			OpenTimer3(T3_ON | T3_SOURCE_INT | T3_PS_1_1, 2*Width+1);
			/** DMA]ݒ@FromAToATCYA]P ***/
			DmaChnSetTxfer(dmaChn, Pattern, (void*)&LATE, MaxRes, 1, 1);		
			DmaChnEnable(dmaChn);					// DMAJn
			mPORTBToggleBits(BIT_3);
			Flag = 0;							// g`XVtOIt
			/***** t\ւ̎g\ ******/
			Pulse = 0.0125*(2*Width+2)*MaxRes;		// usec
			Freq = 1000000/Pulse;					// gɕϊ
			ftostring(6, 1, Pulse, MsgData1+6);		// ɕϊ
			ftostring(6,	1, Freq, MsgData2+5);		// ɕϊ
			lcd_cmd(0x80);						// 1sڕ\
			lcd_str(MsgData1);					// pX\
			lcd_cmd(0xC0);						// 2sڕ\
			lcd_str(MsgData2);					// g\
		}
	}
}

/*****************************************
*   l當ɕϊ
*****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;
	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--) {				//ŉʌʂ
		buffer--;						//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}

/****************************************
*   Float當֕ϊ
* @vL8ȉƂ邱
****************************************/
void ftostring(int seisu, int shousu, float data, char *buffer)
{
	int i;
	long dumy;

	if(shousu != 0)						//肩
		buffer += seisu+shousu+1;			//Š{_
	else								//Ȃ̂Ƃ
		buffer += seisu + shousu;			//Š̂
	buffer--;							//z|C^-1
	for(i=0; i<shousu; i++)				//𐮐ɕϊ
		data = data * 10;					//PO{
	/// dumyI[o[t[ƕϊs(WE)
	dumy = (long) (data + 0.5);			//ľܓĐɕϊ
	for(i=shousu; i>0; i--)	{			//JԂ
		*buffer =(dumy % 10)+'0';			//l𕶎ɕϊi[
		buffer--;						//i[ꏊʂʂ
		dumy /= 10;						//̌
	}
	if(shousu != 0) {						//0Ȃ珬_Ȃ
		*buffer = '.';					//_i[
		buffer--;						//|C^-1
	}
	for(i=seisu; i>0; i--) {				//JԂ
		*buffer = (dumy % 10)+'0';			//l𕶎ɕϊi[
		buffer--;						//|C^-1
		dumy /= 10;						//̌
	}
	i = 0;								// uLO
	buffer++;
	while((i<seisu)&&(*buffer == '0'))		// ʌ0̊
	{
		*buffer = ' ';					// uNɕϊ
		buffer++;
		i++;
	}
}


